//PS2 controller illeszts soros vonalra
//PIC16F1826, 32MHZ,
// hardveres Soros vonal  57600,8,1
// PS2 controller SPI vonalon illesztve, szoftveres SPI vonal
// soros vonalon a lekrdezs .49-el , azaz '1'-el
// nem mkodik a parancs alapjn analg mdba kapcsols
//de a vezrln ott az Analg gomb...


sbit ledpwr           at RA6_bit;   //output active low
sbit ps2_dat          at RB4_bit;  //input    felhuzo ellenallas tapra, mert OC kimenetes a Dpad
sbit ps2_com          at RB5_bit;  //output    parancs megy a Dpadba
sbit ps2_att          at RB6_bit; //output     Attention = az egesz forgalmazas alatt log. alacsony.
sbit ps2_clk          at RB7_bit ; //output     orajel
sbit ps2_ack          at RA7_bit; //input       ezen valaszolna vissza Dpad, hogy rendben, de nem hasznalom...

 unsigned short loop, i,loop2,err,res,tmp,tmp1,data0,data1,data2,data3,data4,data5,psxout,psxin,psxstatus,psxid;      //8bit 0-255
 unsigned short byteIn, byteOut, uartrx;
 
void ledflash(){
 ledpwr =0;
 delay_ms(100);
 ledpwr= 1;
 delay_ms(100);
 ledpwr =0;
 delay_ms(100);
 ledpwr= 1;
 delay_ms(100);
 ledpwr =0;
  }
  

void crlf(){
    uart1_write(13);
    uart1_write(10);
     asm{CLRWDT}
}


void psxTxRx(){
     byteOut = psxout;               //ez fog kimenni a Dpadba.
    byteIn=0;                         //Reset Receive byte
for (i=0;i<8;i++){             //Read data bits LSB to MSB
if (byteOut & 0x01) {
ps2_com = 1;
}
else {
ps2_com = 0;
}

byteOut = byteOut >> 1;

ps2_clk=0 ;                     //Generate clock pulse
delay_us(10);                   //Used to regulate communication speed

byteIn =  byteIn >> 1;              //itt rotldik be hogy byte legyen
if (ps2_dat == 0)   {
byteIn = byteIn + 0x80;               //Low Data line indicates set bit
 }
 


ps2_clk=1;                      //End clock pulse
delay_us(10);                   //Regulate speed
} //for end

 psxin = byteIn;
}   //procedure end


void psx_read(){
        //psxAtt low, Activates Controller
ps2_com = 1;
ps2_clk = 1;
ps2_att = 0;
Delay_us(50);

psxout=0x01;                 //Start Signal
psxTxRx();

psxout=0x42;              //Request Status
psxTxRx();
psxid=psxin;          //       Simultaneously receive controller ID

psxout=0x00;                    //Clear psxOut
psxTxRx();
psxstatus=psxin;

psxTxRx(); //Get Left side buttons
data0=psxin ;

psxTxRx(); //Get Right side buttons
data1=psxin ;

psxTxRx(); //Get Right joystick X-axis byte
data2=psxin ;

psxTxRx(); //Get Right joystick Y-axis byte
data3=psxin;

psxTxRx(); //Get Left joystick X-axis byte
data4=psxin;

psxTxRx(); //Get Left joystick Y-axis byte
data5=psxin;

 ps2_com = 1;
delay_ms(1);
ps2_att = 1;
delay_ms(10);
   //Release controller by setting psxATT high
}

 ps2_analog(){    // itt lenne az a subrutin ami analogba kapcsolja a dpadot,de ez nem uzemel
     // put controller in config mode
ps2_com = 1;
ps2_clk = 1;
ps2_att = 0;
psxout = 0x01;
psxTxRx();
psxout = 0x43;
psxTxRx();
psxout = 0x00;
psxTxRx();
psxout = 0x01;
psxTxRx();
psxout = 0x00;
psxTxRx();
ps2_com = 1;
delay_ms(1);
ps2_att = 1;
delay_ms(10);

		   // put controller in analouge mode
ps2_com = 1;
ps2_clk = 1;
ps2_att = 0;
psxout = 0x01;
psxTxRx();
psxout = 0x44;
psxTxRx();
psxout = 0x00;
psxTxRx();
psxout = 0x01;
psxTxRx();
psxout = 0x03;
psxTxRx();
psxout = 0x00;
psxTxRx();
psxout = 0x00;
psxTxRx();
psxout = 0x00;
psxTxRx();
psxout = 0x00;
psxTxRx();
 ps2_com = 1;
delay_ms(1);
ps2_att = 1;
delay_ms(10);

		   // exit config mode
ps2_com = 1;
ps2_clk = 1;
ps2_att = 0;
psxout = 0x01;
psxTxRx();
psxout = 0x43;
psxTxRx();
psxout = 0x00;
psxTxRx();
psxout = 0x00;
psxTxRx();
psxout = 0x5A;
psxTxRx();
psxout = 0x5A;
psxTxRx();
psxout = 0x5A;
psxTxRx();
psxout = 0x5A;
psxTxRx();
psxout = 0x5A;
psxTxRx();
ps2_com = 1;
delay_ms(1);
ps2_att = 1;
delay_ms(10);
		   // poll controller and check in analouge mode.
ps2_com = 1;
ps2_clk = 1;
ps2_att = 0;
psxout = 0x01;
psxTxRx();
psxout = 0x42;
psxstatus = psxin;
psxTxRx();
psxout = 0x00;
psxTxRx();
psxout = 0x00;
psxTxRx();
psxout = 0x00;
psxTxRx();
psxout = 0x00;
psxTxRx();
psxout = 0x00;
psxTxRx();
psxout = 0x00;
psxTxRx();
psxout = 0x00;
psxTxRx();
 ps2_com = 1;
delay_ms(1);
ps2_att = 1;
delay_ms(10);
ps2_com = 1;
delay_ms(1);
ps2_att = 1;
delay_ms(10);
    //a vlasz a psxin regiszterben trolva.
 }

void main() {
      //a bels oszcilltort belltjuk 32mhz-re.

  delay_ms(20);
  OSCCON = 0xF0; //  1111 0000  van pll, 8x4MHZ,
  PORTA = 0x00;
  PORTB = 0x00;
  LATA = 0x00;
  LATB = 0x00;
  ADCON0  = 0x00;     // AD module kikapcsolva.
  ADCON1 = 0x00;     //  referencia feszltsgek a tprl az AD modulnak.
  ANSELA = 0x00; // digitlis bemenet
  ANSELB = 0x00; // digitlis bemenet
  APFCON0 = 0x00; // alaphelyzetbe megy az RX s TX
  APFCON1 = 0x00;
  TRISA = 0xBF;  // 1011 1111 ra7 in, ra6 ledout, a tobbi nem hasznalatos, gy input
  TRISB = 0x1B; // 0001 1011 rb7 clkout, rb6 attentout, rb5 command out, rb4 data in, rb3 not use, rb2 txout, rb1 rxin, rb0 not use
  WPUB =0x00;   //felhuzoellnsok kikapcsolsa a B porton.
  





 uart1_init(57600);
 ledflash();
 uart1_write_text("Im Alive");
 ps2_com =1;
 ps2_clk =1;
 ps2_att =1;
 
 crlf();
 while(1){

 
 
 


  if (UART1_Data_Ready() == 1) {
      uartrx = uart1_read();
     if(uartrx =='1'){
    psx_read();
    uart1_write(psxid);
    uart1_write(psxstatus);
    uart1_write(data0);
    uart1_write(data1);
    uart1_write(data2);
    uart1_write(data3);
    uart1_write(data4);
    uart1_write(data5);
      }
      
      if(uartrx =='2'){
        uart1_write_text("analog mode answer:");
        uart1_write(psxstatus);
         crlf();
      }

             }  // soros fogadas vege


}  // end while
} // end main